CfnTrialComponent

class aws_cdk.aws_sagemaker.CfnTrialComponent(scope, id, *, trial_component_name, display_name=None, input_artifacts=None, metadata_properties=None, output_artifacts=None, parameters=None, status=None, tags=None)

Bases: CfnResource

Resource type definition for AWS::SageMaker::TrialComponent.

A trial component is a stage of a machine learning trial, such as a preprocessing job, training job, or batch transform job.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-sagemaker-trialcomponent.html

CloudformationResource:

AWS::SageMaker::TrialComponent

ExampleMetadata:

fixture=_generated

Example:

# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_sagemaker as sagemaker

cfn_trial_component = sagemaker.CfnTrialComponent(self, "MyCfnTrialComponent",
    trial_component_name="trialComponentName",

    # the properties below are optional
    display_name="displayName",
    input_artifacts={
        "input_artifacts_key": sagemaker.CfnTrialComponent.TrialComponentArtifactProperty(
            value="value",

            # the properties below are optional
            media_type="mediaType"
        )
    },
    metadata_properties=sagemaker.CfnTrialComponent.MetadataPropertiesProperty(
        commit_id="commitId",
        generated_by="generatedBy",
        project_id="projectId",
        repository="repository"
    ),
    output_artifacts={
        "output_artifacts_key": sagemaker.CfnTrialComponent.TrialComponentArtifactProperty(
            value="value",

            # the properties below are optional
            media_type="mediaType"
        )
    },
    parameters={
        "parameters_key": sagemaker.CfnTrialComponent.TrialComponentParameterValueProperty(
            number_value=123,
            string_value="stringValue"
        )
    },
    status=sagemaker.CfnTrialComponent.TrialComponentStatusProperty(
        message="message",
        primary_status="primaryStatus"
    ),
    tags=[sagemaker.CfnTrialComponent.TagsItemsProperty(
        key="key",
        value="value"
    )]
)

Create a new AWS::SageMaker::TrialComponent.

Parameters:
  • scope (Construct) – Scope in which this resource is defined.

  • id (str) – Construct identifier for this resource (unique in its scope).

  • trial_component_name (str) – The name of the trial component. Must be unique in your AWS account and is not case-sensitive.

  • display_name (Optional[str]) – The name of the component as displayed. If DisplayName isn’t specified, TrialComponentName is displayed.

  • input_artifacts (Union[IResolvable, Mapping[str, Union[IResolvable, TrialComponentArtifactProperty, Dict[str, Any]]], None]) – The input artifacts for the component.

  • metadata_properties (Union[IResolvable, MetadataPropertiesProperty, Dict[str, Any], None]) – Metadata properties of the tracking entity, trial, or trial component.

  • output_artifacts (Union[IResolvable, Mapping[str, Union[IResolvable, TrialComponentArtifactProperty, Dict[str, Any]]], None]) – The output artifacts for the component.

  • parameters (Union[IResolvable, Mapping[str, Union[IResolvable, TrialComponentParameterValueProperty, Dict[str, Any]]], None]) – The hyperparameters for the component.

  • status (Union[IResolvable, TrialComponentStatusProperty, Dict[str, Any], None]) – The status of the trial component.

  • tags (Optional[Sequence[Union[TagsItemsProperty, Dict[str, Any]]]]) – A list of tags to associate with the trial component.

Methods

add_deletion_override(path)

Syntactic sugar for addOverride(path, undefined).

Parameters:

path (str) – The path of the value to delete.

Return type:

None

add_dependency(target)

(deprecated) Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.

Parameters:

target (CfnResource)

Deprecated:

Use addResourceDependency instead.

Stability:

deprecated

Return type:

None

add_depends_on(target)

(deprecated) Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.

Parameters:

target (CfnResource)

Deprecated:

Use addResourceDependency instead.

Stability:

deprecated

Return type:

None

add_metadata(key, value)

Add a value to the CloudFormation Resource Metadata.

Parameters:
  • key (str)

  • value (Any)

See:

Return type:

None

https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/metadata-section-structure.html

Note that this is a different set of metadata from CDK node metadata; this metadata ends up in the stack template under the resource, whereas CDK node metadata ends up in the Cloud Assembly.

add_override(path, value)

Adds an override to the synthesized CloudFormation resource.

To add a property override, either use addPropertyOverride or prefix path with “Properties.” (i.e. Properties.TopicName).

If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.

To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.

For example:

cfn_resource.add_override("Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes", ["myattribute"])
cfn_resource.add_override("Properties.GlobalSecondaryIndexes.1.ProjectionType", "INCLUDE")

would add the overrides Example:

"Properties": {
  "GlobalSecondaryIndexes": [
    {
      "Projection": {
        "NonKeyAttributes": [ "myattribute" ]
        ...
      }
      ...
    },
    {
      "ProjectionType": "INCLUDE"
      ...
    },
  ]
  ...
}

The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.

Parameters:
  • path (str) –

    • The path of the property, you can use dot notation to override values in complex types. Any intermediate keys will be created as needed.

  • value (Any) –

    • The value. Could be primitive or complex.

Return type:

None

add_property_deletion_override(property_path)

Adds an override that deletes the value of a property from the resource definition.

Parameters:

property_path (str) – The path to the property.

Return type:

None

add_property_override(property_path, value)

Adds an override to a resource property.

Syntactic sugar for addOverride("Properties.<...>", value).

Parameters:
  • property_path (str) – The path of the property.

  • value (Any) – The value.

Return type:

None

add_resource_dependency(target, reason=None)

Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.

This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.

Parameters:
Return type:

None

apply_cross_stack_reference_strength(strength)

Sets the cross-stack reference strength for this resource.

When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack’s context.

Parameters:

strength (ReferenceStrength) –

  • The reference strength to use for this resource.

Return type:

None

apply_removal_policy(policy=None, *, apply_to_update_replace_policy=None, default=None)

Sets the deletion policy of the resource based on the removal policy specified.

The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you’ve removed it from the CDK application or because you’ve made a change that requires the resource to be replaced.

The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:

Parameters:
  • policy (Optional[RemovalPolicy])

  • apply_to_update_replace_policy (Optional[bool]) – Apply the same deletion policy to the resource’s “UpdateReplacePolicy”. Default: true

  • default (Optional[RemovalPolicy]) – The default policy to apply in case the removal policy is not defined. Default: - Default value is resource specific. To determine the default value for a resource, please consult that specific resource’s documentation.

See:

https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-attribute-deletionpolicy.html#aws-attribute-deletionpolicy-options

Return type:

None

cfn_property_name(cdk_property_name)
Parameters:

cdk_property_name (str)

Return type:

Optional[str]

get_att(attribute_name, type_hint=None)

Returns a token for an runtime attribute of this resource.

Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.

Parameters:
  • attribute_name (str) – The name of the attribute.

  • type_hint (Optional[ResolutionTypeHint])

Return type:

Reference

get_metadata(key)

Retrieve a value value from the CloudFormation Resource Metadata.

Parameters:

key (str)

See:

Return type:

Any

https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/metadata-section-structure.html

Note that this is a different set of metadata from CDK node metadata; this metadata ends up in the stack template under the resource, whereas CDK node metadata ends up in the Cloud Assembly.

inspect(inspector)

Examines the CloudFormation resource and discloses attributes.

Parameters:

inspector (TreeInspector) – tree inspector to collect and process attributes.

Return type:

None

obtain_dependencies()

Retrieves an array of resources this resource depends on.

This assembles dependencies on resources across stacks (including nested stacks) automatically.

Return type:

List[Union[CfnResource, Stack]]

override_logical_id(new_logical_id)

Overrides the auto-generated logical ID with a specific ID.

Parameters:

new_logical_id (str) – The new logical ID to use for this stack element.

Return type:

None

remove_dependency(target)

(deprecated) Indicates that this resource no longer depends on another resource.

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

Parameters:

target (CfnResource)

Deprecated:

Use removeResourceDependency instead

Stability:

deprecated

Return type:

None

remove_resource_dependency(target)

Indicates that this resource no longer depends on another resource.

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

Parameters:

target (CfnResource)

Return type:

None

replace_dependency(target, new_target)

Replaces one dependency with another.

Parameters:
Return type:

None

to_string()

Returns a string representation of this construct.

Return type:

str

Returns:

a string representation of this resource

with_(*mixins)

Applies one or more mixins to this construct.

Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.

Parameters:

mixins (IMixin)

Return type:

IConstruct

Attributes

CFN_RESOURCE_TYPE_NAME = 'AWS::SageMaker::TrialComponent'
attr_creation_time

When the trial component was created.

CloudformationAttribute:

CreationTime

attr_last_modified_time

When the trial component was last modified.

CloudformationAttribute:

LastModifiedTime

attr_lineage_group_arn

The Amazon Resource Name (ARN) of the lineage group.

CloudformationAttribute:

LineageGroupArn

attr_trial_component_arn

The Amazon Resource Name (ARN) of the trial component.

CloudformationAttribute:

TrialComponentArn

cdk_tag_manager

Tag Manager which manages the tags for this resource.

cfn_options

Options for this resource, such as condition, update policy etc.

cfn_resource_type

AWS resource type.

creation_stack

return:

the stack trace of the point where this Resource was created from, sourced from the +metadata+ entry typed +aws:cdk:logicalId+, and with the bottom-most node +internal+ entries filtered.

display_name

The name of the component as displayed.

env
input_artifacts

The input artifacts for the component.

logical_id

The logical ID for this CloudFormation stack element.

The logical ID of the element is calculated from the path of the resource node in the construct tree.

To override this value, use overrideLogicalId(newLogicalId).

Returns:

the logical ID as a stringified token. This value will only get resolved during synthesis.

metadata_properties

Metadata properties of the tracking entity, trial, or trial component.

node

The tree node.

output_artifacts

The output artifacts for the component.

parameters

The hyperparameters for the component.

ref

Return a string that will be resolved to a CloudFormation { Ref } for this element.

If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).

stack

The stack in which this element is defined.

CfnElements must be defined within a stack scope (directly or indirectly).

status

The status of the trial component.

tags

A list of tags to associate with the trial component.

trial_component_name

The name of the trial component.

trial_component_ref

A reference to a TrialComponent resource.

Static Methods

classmethod arn_for_trial_component(resource)
Parameters:

resource (ITrialComponentRef)

Return type:

str

classmethod is_cfn_element(x)

Returns true if a construct is a stack element (i.e. part of the synthesized cloudformation template).

Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.

Parameters:

x (Any)

Return type:

bool

Returns:

The construct as a stack element or undefined if it is not a stack element.

classmethod is_cfn_resource(x)

Check whether the given object is a CfnResource.

Parameters:

x (Any)

Return type:

bool

classmethod is_cfn_trial_component(x)

Checks whether the given object is a CfnTrialComponent.

Parameters:

x (Any)

Return type:

bool

classmethod is_construct(x)

Checks if x is a construct.

Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.

Parameters:

x (Any) – Any object.

Return type:

bool

Returns:

true if x is an object created from a class which extends Construct.

MetadataPropertiesProperty

class CfnTrialComponent.MetadataPropertiesProperty(*, commit_id=None, generated_by=None, project_id=None, repository=None)

Bases: object

Metadata properties of the tracking entity, trial, or trial component.

Parameters:
  • commit_id (Optional[str]) – The commit ID.

  • generated_by (Optional[str]) – The entity this entity was generated by.

  • project_id (Optional[str]) – The project ID.

  • repository (Optional[str]) – The repository.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-metadataproperties.html

ExampleMetadata:

fixture=_generated

Example:

# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_sagemaker as sagemaker

metadata_properties_property = sagemaker.CfnTrialComponent.MetadataPropertiesProperty(
    commit_id="commitId",
    generated_by="generatedBy",
    project_id="projectId",
    repository="repository"
)

Attributes

commit_id

The commit ID.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-metadataproperties.html#cfn-sagemaker-trialcomponent-metadataproperties-commitid

generated_by

The entity this entity was generated by.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-metadataproperties.html#cfn-sagemaker-trialcomponent-metadataproperties-generatedby

project_id

The project ID.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-metadataproperties.html#cfn-sagemaker-trialcomponent-metadataproperties-projectid

repository

The repository.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-metadataproperties.html#cfn-sagemaker-trialcomponent-metadataproperties-repository

TagsItemsProperty

class CfnTrialComponent.TagsItemsProperty(*, key, value)

Bases: object

Parameters:
  • key (str) – The tag key.

  • value (str) – The tag value.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-tagsitems.html

ExampleMetadata:

fixture=_generated

Example:

# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_sagemaker as sagemaker

tags_items_property = sagemaker.CfnTrialComponent.TagsItemsProperty(
    key="key",
    value="value"
)

Attributes

key

The tag key.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-tagsitems.html#cfn-sagemaker-trialcomponent-tagsitems-key

value

The tag value.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-tagsitems.html#cfn-sagemaker-trialcomponent-tagsitems-value

TrialComponentArtifactProperty

class CfnTrialComponent.TrialComponentArtifactProperty(*, value, media_type=None)

Bases: object

Represents an input or output artifact of a trial component.

Parameters:
  • value (str) – The location of the artifact.

  • media_type (Optional[str]) – The media type of the artifact.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-trialcomponentartifact.html

ExampleMetadata:

fixture=_generated

Example:

# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_sagemaker as sagemaker

trial_component_artifact_property = sagemaker.CfnTrialComponent.TrialComponentArtifactProperty(
    value="value",

    # the properties below are optional
    media_type="mediaType"
)

Attributes

media_type

The media type of the artifact.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-trialcomponentartifact.html#cfn-sagemaker-trialcomponent-trialcomponentartifact-mediatype

value

The location of the artifact.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-trialcomponentartifact.html#cfn-sagemaker-trialcomponent-trialcomponentartifact-value

TrialComponentParameterValueProperty

class CfnTrialComponent.TrialComponentParameterValueProperty(*, number_value=None, string_value=None)

Bases: object

The value of a hyperparameter.

Only one of StringValue or NumberValue can be specified.

Parameters:
  • number_value (Union[int, float, None]) – The numeric value of a numeric hyperparameter.

  • string_value (Optional[str]) – The string value of a categorical hyperparameter.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-trialcomponentparametervalue.html

ExampleMetadata:

fixture=_generated

Example:

# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_sagemaker as sagemaker

trial_component_parameter_value_property = sagemaker.CfnTrialComponent.TrialComponentParameterValueProperty(
    number_value=123,
    string_value="stringValue"
)

Attributes

number_value

The numeric value of a numeric hyperparameter.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-trialcomponentparametervalue.html#cfn-sagemaker-trialcomponent-trialcomponentparametervalue-numbervalue

string_value

The string value of a categorical hyperparameter.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-trialcomponentparametervalue.html#cfn-sagemaker-trialcomponent-trialcomponentparametervalue-stringvalue

TrialComponentStatusProperty

class CfnTrialComponent.TrialComponentStatusProperty(*, message=None, primary_status=None)

Bases: object

The status of the trial component.

Parameters:
  • message (Optional[str]) – If the component failed, a message describing why.

  • primary_status (Optional[str]) – The status of the trial component.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-trialcomponentstatus.html

ExampleMetadata:

fixture=_generated

Example:

# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_sagemaker as sagemaker

trial_component_status_property = sagemaker.CfnTrialComponent.TrialComponentStatusProperty(
    message="message",
    primary_status="primaryStatus"
)

Attributes

message

If the component failed, a message describing why.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-trialcomponentstatus.html#cfn-sagemaker-trialcomponent-trialcomponentstatus-message

primary_status

The status of the trial component.

See:

http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-properties-sagemaker-trialcomponent-trialcomponentstatus.html#cfn-sagemaker-trialcomponent-trialcomponentstatus-primarystatus